﻿© 2008 Fluke Corporation, All rights reserved               MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Check MET/CAL Version
DATE:                  2008-12-12 10:08:41
AUTHOR:                Fluke
REVISION:              $Revision: 5516 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       115
=============================================================================
#
#  Procedure Author:
#    DAC
#
#  Compatibility:
#    5500/CAL or MET/CAL 5.10 later
#
#  Subprocedures:
#    None
#
#  Required Files:
#    None
#
#  Example Usage:
#
#    1.001  MATH         PUT("Req_METCAL_Version", "7.11b")
#    1.003  CALL         Sub Check MET/CAL Version
#
#    1.004  IF           NOT(VERSIONCHECK("7.3.38"))
#    1.005  DISP         This procedure require MET/CAL or 5500/CAL 7.11b or
#    1.006  DISP         later.
#    1.007  END
#    1.008  ENDIF
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  MATH         S[10] = GET("Req_METCAL_Version"); L[10] = S[10]
  1.002  MATH         S[12] = VERS(); L[12] = S[12]

# If required version is greater than current version...
  1.003  IF           L[10] > L[12]
  1.004  MATH         PUT("METCAL_Version_OK", 0)

# If required version is less than current version...
  1.005  ELSEIF       L[10] < L[12]
  1.006  MATH         PUT("METCAL_Version_OK", 1)

# if required version is not an interim release...
  1.007  ELSEIF       LEN(S[10]) < 5
  1.008  MATH         PUT("METCAL_Version_OK", 1)

# if required version is an interim release and no interim version released...
  1.009  ELSEIF       LEN(S[12]) < 5
  1.010  MATH         PUT("METCAL_Version_OK", 0)

# Required version is an interim release and current version is an interim
# release.  Check version suffix.
  1.011  ELSE
  1.012  MATH         S[11] = SUB(S[10], 5, 1)
  1.013  MATH         S[13] = SUB(S[12], 5, 1)

# Make sure required suffix is is a-z or A-Z.
  1.014  IF           LEN(S[11]) == 1
  1.015  MATH         L[11] = CTOI(S[11])
  1.016  MATH         L[2] = (L[11] >= CTOI("a")) && (L[11] <= CTOI("z"))
  1.017  MATH         L[3] = (L[11] >= CTOI("A")) && (L[11] <= CTOI("Z"))

  1.018  IF           L[2] || L[3]
  1.019  MATH         PUT("Version_Suffix_OK", 1)
  1.020  ELSE
  1.021  MATH         PUT("Version_Suffix_OK", 0)
  1.022  ENDIF

  1.023  ELSE
  1.024  MATH         PUT("Version_Suffix_OK", 0)
  1.025  ENDIF

  1.026  IF           GET("Version_Suffix_OK") != 1
  1.027  DISP         Error in "Sub Check MET/CAL Version".
  1.027  DISP
  1.027  DISP         "Req_METCAL_Version" suffix must be a-z or A-Z.
  1.028  MATH         PUT("METCAL_Version_OK", 0)
  1.029  END
  1.030  ENDIF

  1.031  MATH         L[21] = CTOI(S[13])

# MET/CAL considers a version with a capital letter suffix to be a later
# release than a service pack with a lowercase letter suffix. However, the
# ASCII standard assigns a lower numeric value to capital letters than their
# lowercase equivalent.  To compensate for this in the numeric comparison
# below, uppercase letters are doubled for determination of minimum required
# version.

  1.032  IF           L[11] < CTOI("a")
  1.033  MATH         L[11] = L[11] * 2
  1.034  ENDIF

  1.035  IF           L[21] < CTOI("a")
  1.036  MATH         L[21] = L[21] * 2
  1.037  ENDIF

  1.038  IF           L[11] > L[21]
  1.039  MATH         PUT("METCAL_Version_OK", 0)
  1.040  ELSE
  1.041  MATH         PUT("METCAL_Version_OK", 1)
  1.042  ENDIF

  1.043  ENDIF

  1.044  END
